/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <string.h>

#include "global.hpp"

//#define 	DEBUG


void conectar(void)
{
	if(conectado == FALSO)
	{
		printf("Nombre del servidor: ");
		scanf("%s" , servidor);
		printf("Numero de puerto: ");
		scanf("%d" , &puerto_m);
		mon->conectar();
		if(conectado == CIERTO) ventana->redibujar(1);
#ifdef DEBUG
		printf("Me conecto al servidor '%s' %d\n" , servidor , conectado);
		if(fichero == CIERTO) fprintf(accion , "Me conecto al servidor '%s' %d\n" , servidor , conectado);
#endif
	}
}

void poner_escala(void)
{
 float esc = 1;

	printf("Escala: ");
	scanf("%f" , &esc);
	ventana->fijar_escala(esc);
#ifdef DEBUG
	printf("La escala es: %f\n" , ventana->di_escala());
	if(fichero == CIERTO) fprintf(accion , "La escala es: %f\n" , ventana->di_escala());
#endif
}

void poner_origen_x(void)
{
 int org = 0;

	if(conectado == CIERTO)
	{
		printf("Origen x: ");
		scanf("%d" , &org);
		ventana->fijar_origen_x(org);
		ventana->redibujar(1);
		ventana->poner_informacion();
#ifdef DEBUG
		printf("El origen x es: %d\n" , ventana->di_origen_x());
		if(fichero == CIERTO) fprintf(accion , "El origen x es: %d\n" , ventana->di_origen_x());
#endif
	}
}

void poner_origen_y(void)
{
 int org = 0;

	if(conectado == CIERTO)
	{
		printf("Origen y: ");
		scanf("%d" , &org);
		ventana->fijar_origen_y(org);
		ventana->redibujar(1);
		ventana->poner_informacion();
#ifdef DEBUG
		printf("El origen y es: %d\n" , ventana->di_origen_y());
		if(fichero == CIERTO) fprintf(accion , "El origen y es: %d\n" , ventana->di_origen_y());
#endif
	}
}

void ventana_info::crear(void)
{
 char *color[NUM_COLOR] = { "white" , "Yellow" , "light blue" , "Cyan" , "Green" , "Steel blue" , "Grey" , "purple" ,
					"Hot pink" , "Magenta" , "Violet" , "Dark Orange" , "Blue" , "Red" , "gainsboro" , "Black" };
 XColor RGB_color , color_real;
 Colormap mapa_color;
 int screen;
 XSizeHints hint;
 unsigned long foreground , background;

	display = XOpenDisplay("");
	screen = DefaultScreen(display);
	background = WhitePixel(display , screen);
	foreground = BlackPixel(display , screen);
	hint.x = 0;
	hint.y = 0;
	hint.width = 500;
	hint.height = 500;
	hint.flags = PPosition | PSize;
	window = XCreateSimpleWindow(display , DefaultRootWindow(display) ,
		hint.x , hint.y , hint.width , hint.height , 7 ,
		foreground , background);
	XSetStandardProperties(display , window , "SimDAI  V 1.0  -  Monitor" ,
		"SimDAI" , None , NULL , 0 , &hint);
	gc = XCreateGC(display , window , 0 , 0);
	XSetBackground(display , gc , background);
	XSetForeground(display , gc , foreground);
	XSelectInput(display , window , (KeyPressMask | ExposureMask));
	mapa_color = DefaultColormap(display , screen);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
	for(int i = 0 ; i < NUM_COLOR ; i++)
		if(XLookupColor(display , mapa_color , color[i] , &RGB_color , &color_real) != 0
			&& XAllocColor(display , mapa_color , &color_real) != 0)
			colores[i] = color_real.pixel;
#ifdef DEBUG
	printf("Localizo los colores\n");
	if (fichero == CIERTO) fprintf(accion , "Localizo los colores\n");
#endif
	XMapRaised(display , window);
	XFlush(display);
}

void ventana_info::liberar(void)
{
	XFreeGC(display , gc);
	XDestroyWindow(display , window);
	XCloseDisplay(display);
	XFlush(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(int borrar)
{
 int x = (int)((maxx - origen_x) * escala);
 int y = (int)((maxy - origen_y) * escala);

#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
	if(borrar != 0) XClearWindow(display , window);
	XSetForeground(display , gc , colores[NUM_COLOR-1]);
	XDrawRectangle(display , window , gc , 0 , 0 , x , y);
	if(conectado == CIERTO && mon->di_activo() == CIERTO)
	{
#ifdef DEBUG
		printf("Dibujo la ventana de informacion2\n");
		if (fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion2\n");
#endif
		sprintf(msg_sale , "MEF");
		mon->enviar_msg(mon->di_sock());
		mon->recibir_msg(mon->di_sock() , "MUF" , 0);
		sprintf(msg_sale , "MER");
		mon->enviar_msg(mon->di_sock());
		mon->recibir_msg(mon->di_sock() , "MUR" , 0);
	}
#ifdef DEBUG
	printf("Evento de exposicion\n");
	if (fichero == CIERTO) fprintf(accion , "Evento de exposicion\n");
#endif
	XFlush(display);
}

int eventos(Display *display , XEvent *evento , char *nada)
{
 KeySym key;
 char buffer[8];
 int teclas;

	XNextEvent(display , evento);
	switch(evento->type)
	{
	   case Expose:
		if(evento->xexpose.count == 0)
		{
#ifdef DEBUG
			printf("Nuevo evento de esposicion\n");
			if (fichero == CIERTO) fprintf(accion , "Nuevo evento de esposicion\n");
#endif
			ventana->redibujar(0);
		}
		break;

	   case MappingNotify:
		XRefreshKeyboardMapping((struct XMappingEvent *) evento);
		break;

	   case KeyPress:
		teclas = XLookupString((struct XKeyEvent *) evento , buffer , 8 , &key , 0);
		if (teclas == 1 && buffer[0] == 'q') { if(conectado == CIERTO) mon->desconectar(); acabar = final = CIERTO; }
		else if (teclas == 1 && buffer[0] == 's') { if(conectado == CIERTO) mon->parar(); }
		else if (teclas == 1 && buffer[0] == 'c') conectar();
		else if (teclas == 1 && buffer[0] == 'd') { if(conectado == CIERTO) mon->desconectar(); }
		else if (teclas == 1 && buffer[0] == '+') { if(conectado == CIERTO) ventana->inc_escala(); }
		else if (teclas == 1 && buffer[0] == '-') { if(conectado == CIERTO) ventana->dec_escala(); }
		else if (teclas == 1 && buffer[0] == 'e') { if(conectado == CIERTO) poner_escala(); }
		else if (teclas == 1 && buffer[0] == 'a') { if(conectado == CIERTO) ventana->dec_origen_y(); }
		else if (teclas == 1 && buffer[0] == 'z') { if(conectado == CIERTO) ventana->inc_origen_y(); }
		else if (teclas == 1 && buffer[0] == 'o') { if(conectado == CIERTO) ventana->dec_origen_x(); }
		else if (teclas == 1 && buffer[0] == 'p') { if(conectado == CIERTO) ventana->inc_origen_x(); }
		else if (teclas == 1 && buffer[0] == 'y') poner_origen_y();
		else if (teclas == 1 && buffer[0] == 'x') poner_origen_x();
		else if (teclas == 1 && buffer[0] == 'f') ventana->redibujar(1);
#ifdef DEBUG
		printf("Se ha pulsado la tecla %c\n" , buffer[0]);
		if (fichero == CIERTO) fprintf(accion , "Se ha pulsado la tecla %c\n" , buffer[0]);
#endif
		break;
	   default:
#ifdef DEBUG
	        printf("Nuevo evento no seleccionado\n");
	        if (fichero == CIERTO) fprintf(accion , "Nuevo evento no seleccionado\n");
#endif
		break;
	}
	return(0);
}

void ventana_info::comprobar_eventos(void)
{
	XCheckIfEvent(display , &evento , eventos , NULL);
}

void ventana_info::inc_origen_y(void)
{
 XWindowAttributes attr;

	XGetWindowAttributes(display , window , &attr);
	if( (origen_y + maxy) * escala > attr.height)
	{
		origen_y+=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_y es: %f\n" , origen_y);
	if(fichero == CIERTO) fprintf(accion , "El origen_y es: %f\n" , origen_y);
#endif
}

void ventana_info::inc_origen_x(void)
{
 XWindowAttributes attr;

	XGetWindowAttributes(display , window , &attr);
	if( (origen_x + maxx) * escala > attr.width)
	{
		origen_x+=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_x es: %f\n" , origen_x);
	if(fichero == CIERTO) fprintf(accion , "El origen_x es: %f\n" , origen_x);
#endif
}

void ventana_info::dec_origen_y(void)
{ 
	if(origen_y > 24)
	{
		origen_y-=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_y es: %f\n" , origen_y);
	if(fichero == CIERTO) fprintf(accion , "El origen_y es: %f\n" , origen_y);
#endif
}

void ventana_info::dec_origen_x(void)
{
	if(origen_x > 24)
	{
		origen_x-=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_x es: %f\n" , origen_x);
	if(fichero == CIERTO) fprintf(accion , "El origen_x es: %f\n" , origen_x);
#endif
}

void ventana_info::dibujar_punto(void)
{
 float x , y;
 unsigned char color;

 	sscanf(msg_entra , "MFU%f %f %c" , &x , &y , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo el punto %d %d %d\n" , (int)x , (int)y , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el punto %d %d %d\n" , (int)x , (int)y , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawPoint(display , window , gc , (int)x , (int)y);
}

void ventana_info::dibujar_recta(void)
{
 float x1 , y1 , x2 , y2;
 unsigned char color;

 	sscanf(msg_entra , "MFR%f %f %f %f %c" , &x1 , &y1 , &x2 , &y2 , &color);
	x1 = (x1 - origen_x) * escala;
	y1 = (y1 - origen_y) * escala;
	x2 = (x2 - origen_x) * escala;
	y2 = (y2 - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo la recta %d %d %d %d %d\n" , (int)x1 , (int)y1 , (int)x2 , (int)y2 , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo la recta %d %d %d %d %d\n" , (int)x1 , (int)y1 , (int)x2 , (int)y2 , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawLine(display , window , gc , (int)x1 , (int)y1 , (int)x2 , (int)y2);
}

void ventana_info::dibujar_circulo(void)
{
 float x , y;
 int radio;
 unsigned char color;

 	sscanf(msg_entra , "MFC%f %f %d %c" , &x , &y , &radio , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
	radio = (int)(radio * escala);
#ifdef DEBUG
	printf("Dibujo el circulo %d %d %d %d\n" , (int)x , (int)y , radio , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el circulo %d %d %d %d\n" , (int)x , (int)y , radio , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XFillArc(display , window , gc , (int)x - radio , (int)y - radio , 2 * radio , 2 * radio , 0 , 360 * 64);
}

void ventana_info::dibujar_sector(void)
{
 float x , y;
 int radio , ang1 , ang2;
 unsigned char color;

 	sscanf(msg_entra , "MFS%f %f %d %d %d %c" , &x , &y , &radio , &ang1 , &ang2 , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
	radio = (int)(radio * escala);
#ifdef DEBUG
	printf("Dibujo el sector %d %d %d %d %d %d\n" , (int)x , (int)y , radio , ang1 , ang2 , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el sector %d %d %d %d %d %d\n" , (int)x , (int)y , radio , ang1 , ang2 , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XFillArc(display , window , gc , (int)x - radio , (int)y - radio , 2 * radio , 2 * radio , ang1 * 64 , ang2 * 64);
}

void ventana_info::dibujar_poligono(void)
{
 int n_lados,i;
 unsigned char color;
 float a , b;
 XPoint *puntos;

	sscanf(msg_entra , "MFP%d %c" , &n_lados , &color);
#ifdef DEBUG
	printf("Dibujo el poligono %d %d \n" , n_lados , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el poligono %d %d\n" , n_lados , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	puntos = new(XPoint[n_lados]);
	for(i = 0 ; i < n_lados ; i++)
	{
		mon->recibir_msg(mon->di_sock() , "MPP" , 0);
		sscanf(msg_entra , "MPP%f %f" , &a , &b);
		puntos[i].x = (short)( (a - origen_x) * escala);
		puntos[i].y = (short)( (b - origen_y) * escala);
#ifdef DEBUG
		printf("Dibujo el punto %d %d\n" , (int)puntos[i].x , (int)puntos[i].y);
		if (fichero == CIERTO) fprintf(accion , "Dibujo el punto %d %d\n" , (int)puntos[i].x , (int)puntos[i].y);
#endif
	}
	XFillPolygon(display , window , gc , puntos , n_lados , Convex , CoordModeOrigin);
	XFlush(display);
}

void ventana_info::dibujar_texto(void)
{
 float x , y;
 unsigned char color;
 char texto[30];

	sscanf(msg_entra , "MFT%f %f %c %s" , &x , &y , &color , texto);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo el texto %d %d '%s' %d\n" , (int)x , (int)y , texto , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el texto %d %d '%s' %d\n" , (int)x , (int)y , texto , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawString(display , window , gc , (int)x , (int)y , texto , strlen(texto));
	XFlush(display);
}

void ventana_info::poner_informacion(void)
{
}
