/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Box.h>

#include "global.hpp"

//#define 	DEBUG


XtAppContext contexto;
Widget aplicacion , dibujo , info , acerca , ayuda;

void ver_dibujar(Widget w , caddr_t dato , XEvent *evento, char *nada)
{
	ventana->redibujar(0);
}

void parar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) mon->parar();
}

void terminar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) mon->desconectar();
	acabar = final = CIERTO;
}

void conectar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == FALSO)
	{
		printf("Nombre del servidor: ");
		scanf("%s" , servidor);
		printf("Numero de puerto: ");
		scanf("%d" , &puerto_m);
		mon->conectar();
		if(conectado == CIERTO) ventana->redibujar(1);
#ifdef DEBUG
		printf("Me conecto al servidor '%s' %d\n" , servidor , conectado);
		if(fichero == CIERTO) fprintf(accion , "Me conecto al servidor '%s' %d\n" , servidor , conectado);
#endif
	}
}

void desconectar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) mon->desconectar();
}

void refrescar(Widget w , XtPointer dato , XtPointer nada)
{
	ventana->redibujar(1);
}

void aumentar_escala(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->inc_escala();
		ventana->poner_informacion();
#ifdef DEBUG
		printf("La escala es: %f\n" , ventana->di_escala());
		if(fichero == CIERTO) fprintf(accion , "La escala es: %f\n" , ventana->di_escala());
#endif
	}
}

void disminuir_escala(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->dec_escala();
		ventana->poner_informacion();
#ifdef DEBUG
		printf("La escala es: %f\n" , ventana->di_escala());
		if(fichero == CIERTO) fprintf(accion , "La escala es: %f\n" , ventana->di_escala());
#endif
	}
}

void poner_escala(Widget w , XtPointer dato , XtPointer nada)
{
 float esc = 1;

	if(conectado == CIERTO)
	{
		printf("Escala: ");
		scanf("%f" , &esc);
		ventana->fijar_escala(esc);
		ventana->poner_informacion();
#ifdef DEBUG
		printf("La escala es: %f\n" , ventana->di_escala());
		if(fichero == CIERTO) fprintf(accion , "La escala es: %f\n" , ventana->di_escala());
#endif
	}
}

void aumentar_origen_x(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->inc_origen_x();
		ventana->poner_informacion();
	}
}

void disminuir_origen_x(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->dec_origen_x();
		ventana->poner_informacion();
	}
}

void poner_origen_x(Widget w , XtPointer dato , XtPointer nada)
{
 int org = 0;

	if(conectado == CIERTO)
	{
		printf("Origen x: ");
		scanf("%d" , &org);
		ventana->fijar_origen_x(org);
		ventana->redibujar(1);
		ventana->poner_informacion();
#ifdef DEBUG
		printf("El origen x es: %d\n" , ventana->di_origen_x());
		if(fichero == CIERTO) fprintf(accion , "El origen x es: %d\n" , ventana->di_origen_x());
#endif
	}
}

void aumentar_origen_y(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->inc_origen_y();
		ventana->poner_informacion();
	}
}

void disminuir_origen_y(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO)
	{
		ventana->dec_origen_y();
		ventana->poner_informacion();
	}
}

void poner_origen_y(Widget w , XtPointer dato , XtPointer nada)
{
 int org = 0;

	if(conectado == CIERTO)
	{
		printf("Origen y: ");
		scanf("%d" , &org);
		ventana->fijar_origen_y(org);
		ventana->redibujar(1);
		ventana->poner_informacion();
#ifdef DEBUG
		printf("El origen y es: %d\n" , ventana->di_origen_y());
		if(fichero == CIERTO) fprintf(accion , "El origen y es: %d\n" , ventana->di_origen_y());
#endif
	}
}

void ver_acerca(Widget w , XtPointer dato , XtPointer nada)
{
}

void ver_ayuda(Widget w , XtPointer dato , XtPointer nada)
{
}

void ventana_info::crear(void)
{
 char *color[NUM_COLOR]={ "white" , "Yellow" , "light blue" , "Cyan" , "Green" , "Steel blue" , "Grey" , "purple",
					"Hot pink" , "Magenta" , "Violet" , "Dark Orange" , "Blue" , "Red" , "gainsboro" , "Black" };
 XColor RGB_color , color_real;
 Colormap mapa_color;
 int screen;
 char *nombre[] = { "SimDAI  V 1.0   -   Monitor" };
 Widget shell , barra , boton1 , boton2 , boton3 , boton4 , menu1 , menu2 , menu3 , menu4 , opcion;
 int i = 1;
 static char *recursos[] = {
	"*Box*background:				White",
	"*SimpleMenu*foreground:			SteelBlue",
	"*MenuButton.foreground:			Red",
	"*font:						*times*medium*18*iso8859-1",
	"*boton1.label:				Fin",
	"*boton2.label:				Conexion",
	"*boton3.label:				Opciones",
	"*boton4.label:				Ayuda",
	"*SimpleMenu*SmeBSB*RowHeight:	25",
	"*SimpleMenu*SmeLine*height:		10",
	"*dibujo.width:				500",
	"*dibujo.height:				500",
	"*barra.width:					500",
	"*info.width:					500",
	"*Label.justify:				Center",
	"*acerca.width:				200",
	"*acerca.height:				100",
	"*ayuda.width:					200",
	"*ayuda.height:				100",
	NULL
 };

	aplicacion = XtVaAppInitialize(&contexto , "XSimDAI.Mon" , NULL , 0 , &i , nombre , recursos , NULL);

	shell = XtVaCreateManagedWidget("shell" , boxWidgetClass , aplicacion , NULL);

	barra = XtVaCreateManagedWidget("barra" , boxWidgetClass , shell , NULL);

	boton1 = XtVaCreateManagedWidget("boton1" , menuButtonWidgetClass , barra , NULL);
	boton2 = XtVaCreateManagedWidget("boton2" , menuButtonWidgetClass , barra , NULL);
	boton3 = XtVaCreateManagedWidget("boton3" , menuButtonWidgetClass , barra , NULL);
	boton4 = XtVaCreateManagedWidget("boton4" , menuButtonWidgetClass , barra , NULL);

	menu1 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton1 , NULL , 0);
	menu2 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton2 , NULL , 0);
	menu3 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton3 , NULL , 0);
	menu4 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton4 , NULL , 0);

	opcion = XtCreateManagedWidget("Parar / Continuar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , parar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea11" , smeLineObjectClass , menu1 , NULL , 0);
	opcion = XtCreateManagedWidget("Terminar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , terminar , (XtPointer) i);

	opcion = XtCreateManagedWidget("Conectar" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , conectar , (XtPointer) i);
	opcion = XtCreateManagedWidget("Desconectar" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , desconectar , (XtPointer) i);

	opcion = XtCreateManagedWidget("Refrescar" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , refrescar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea21" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Aumentar escala" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , aumentar_escala , (XtPointer) i);
	opcion = XtCreateManagedWidget("Disminuir escala" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , disminuir_escala , (XtPointer) i);
	opcion = XtCreateManagedWidget("Fijar escala" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , poner_escala , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea22" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Aumentar origen X" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , aumentar_origen_x , (XtPointer) i);
	opcion = XtCreateManagedWidget("Disminuir origen X" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback,disminuir_origen_x,(XtPointer) i);
	opcion = XtCreateManagedWidget("Fijar origen X" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback,poner_origen_x,(XtPointer) i);
	opcion = XtCreateManagedWidget("linea23" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Aumentar origen Y" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , aumentar_origen_y, (XtPointer) i);
	opcion = XtCreateManagedWidget("Disminuir origen Y" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , disminuir_origen_y,(XtPointer) i);
	opcion = XtCreateManagedWidget("Fijar origen Y" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback,poner_origen_y,(XtPointer) i);

	opcion = XtCreateManagedWidget("Acerca" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_acerca , (XtPointer) i);
	opcion = XtCreateManagedWidget("Ayuda" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_ayuda , (XtPointer) i);

	dibujo = XtCreateManagedWidget("dibujo" , simpleWidgetClass , shell , NULL , 0);
	display = XtDisplay(dibujo);
	screen = DefaultScreen(display);
	XtAddEventHandler(dibujo , ExposureMask , FALSE , ver_dibujar , NULL);
	gc = XtGetGC(dibujo , 0 , 0);
	XSetForeground(display , gc , BlackPixel(display , screen) );
	XSetBackground(display , gc , WhitePixel(display , screen) );

	info = XtCreateManagedWidget("info" , labelWidgetClass , shell , NULL , 0);

	acerca = XtCreatePopupShell("acerca" , transientShellWidgetClass , shell , NULL , 0);

	ayuda = XtCreatePopupShell("ayuda" , transientShellWidgetClass , shell , NULL , 0);

	mapa_color = DefaultColormap(display , screen);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
	for(i = 0 ; i < NUM_COLOR ; i++)
		if( XLookupColor(display , mapa_color , color[i] , &RGB_color , &color_real) != 0
			&& XAllocColor(display , mapa_color , &color_real) != 0)
			colores[i] = color_real.pixel;
#ifdef DEBUG
	printf("Localizo los colores\n");
	if (fichero == CIERTO) fprintf(accion , "Localizo los colores\n");
#endif
	XtRealizeWidget(aplicacion);
	window = XtWindow(dibujo);
	this->poner_informacion();
}

void ventana_info::liberar(void)
{
	XtReleaseGC(dibujo , gc);
	XtRemoveEventHandler(dibujo , ExposureMask , FALSE , ver_dibujar , NULL);
	XtCloseDisplay(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(int borrar)
{
 int x = (int)((maxx - origen_x) * escala);
 int y = (int)((maxy - origen_y) * escala);

#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if (fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
	if(borrar != 0) XClearWindow(display , window);
	XSetForeground(display , gc , colores[NUM_COLOR-1]);
	XDrawRectangle(display , window , gc , 0 , 0 , x , y);
	if(conectado == CIERTO && mon->di_activo() == CIERTO)
	{
		sprintf(msg_sale , "MEF");
		mon->enviar_msg(mon->di_sock());
		mon->recibir_msg(mon->di_sock() , "MUF" , 0);
		sprintf(msg_sale , "MER");
		mon->enviar_msg(mon->di_sock());
		mon->recibir_msg(mon->di_sock() , "MUR" , 0);
	}
#ifdef DEBUG
	printf("Evento de exposicion\n");
	if (fichero == CIERTO) fprintf(accion , "Evento de exposicion\n");
#endif
}

void ventana_info::comprobar_eventos(void)
{
	if (XtAppPending(contexto) != 0)
	{
		XtAppNextEvent(contexto , &evento);
		XtDispatchEvent(&evento);
	}
	else XFlush(display);
}

void ventana_info::inc_origen_y(void)
{
 XWindowAttributes attr;

	XGetWindowAttributes(display , window , &attr);
	if( (origen_y + maxy) * escala > attr.height)
	{
		origen_y+=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_y es: %f\n" , origen_y);
	if(fichero == CIERTO) fprintf(accion , "El origen_y es: %f\n" , origen_y);
#endif
}

void ventana_info::inc_origen_x(void)
{
 XWindowAttributes attr;

	XGetWindowAttributes(display , window , &attr);
	if( (origen_x + maxx) * escala > attr.width)
	{
		origen_x+=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_x es: %f\n" , origen_x);
	if(fichero == CIERTO) fprintf(accion , "El origen_x es: %f\n" , origen_x);
#endif
}

void ventana_info::dec_origen_y(void)
{ 
	if(origen_y > 24)
	{
		origen_y-=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_y es: %f\n" , origen_y);
	if(fichero == CIERTO) fprintf(accion , "El origen_y es: %f\n" , origen_y);
#endif
}

void ventana_info::dec_origen_x(void)
{
	if(origen_x > 24)
	{
		origen_x-=25;
		redibujar(1);
	}
#ifdef DEBUG
	printf("El origen_x es: %f\n" , origen_x);
	if(fichero == CIERTO) fprintf(accion , "El origen_x es: %f\n" , origen_x);
#endif
}

void ventana_info::dibujar_punto(void)
{
 float x , y;
 unsigned char color;

 	sscanf(msg_entra , "MFU%f %f %c" , &x , &y , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo el punto %d %d %d\n" , (int)x , (int)y , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el punto %d %d %d\n" , (int)x , (int)y , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawPoint(display , window , gc , (int)x , (int)y);
}

void ventana_info::dibujar_recta(void)
{
 float x1 , y1 , x2 , y2;
 unsigned char color;

 	sscanf(msg_entra , "MFR%f %f %f %f %c" , &x1 , &y1 , &x2 , &y2 , &color);
	x1 = (x1 - origen_x) * escala;
	y1 = (y1 - origen_y) * escala;
	x2 = (x2 - origen_x) * escala;
	y2 = (y2 - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo la recta %d %d %d %d %d\n" , (int)x1 , (int)y1 , (int)x2 , (int)y2 , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo la recta %d %d %d %d %d\n" , (int)x1 , (int)y1 , (int)x2 , (int)y2 , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawLine(display , window , gc , (int)x1 , (int)y1 , (int)x2 , (int)y2);
}

void ventana_info::dibujar_circulo(void)
{
 float x , y;
 int radio;
 unsigned char color;

 	sscanf(msg_entra , "MFC%f %f %d %c" , &x , &y , &radio , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
	radio = (int)(radio * escala);
#ifdef DEBUG
	printf("Dibujo el circulo %d %d %d %d\n" , (int)x , (int)y , radio , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el circulo %d %d %d %d\n" , (int)x , (int)y , radio , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XFillArc(display , window , gc , (int)x - radio , (int)y - radio , 2 * radio , 2 * radio , 0 , 360 * 64);
}

void ventana_info::dibujar_sector(void)
{
 float x , y , aux;
 int radio , ang1 , ang2;
 unsigned char color;

 	sscanf(msg_entra , "MFS%f %f %d %d %d %c" , &x , &y , &radio , &ang1 , &ang2 , &color);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
	radio = (int)(radio * escala);
#ifdef DEBUG
	printf("Dibujo el sector %d %d %d %d %d %d\n" , (int)x , (int)y , radio , ang1 , ang2 , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el sector %d %d %d %d %d %d\n" , (int)x , (int)y , radio , ang1 , ang2 , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XFillArc(display , window , gc , (int)x - radio , (int)y - radio , 2 * radio, 2 * radio , ang1 * 64 , ang2 * 64);
}

void ventana_info::dibujar_poligono(void)
{
 int n_lados,i;
 unsigned char color;
 float a , b;
 XPoint *puntos;

	sscanf(msg_entra , "MFP%d %c" , &n_lados , &color);
#ifdef DEBUG
	printf("Dibujo el poligono %d %d \n" , n_lados , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el poligono %d %d\n" , n_lados , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	puntos = new(XPoint[n_lados]);
	for(i = 0 ; i < n_lados ; i++)
	{
		mon->recibir_msg(mon->di_sock() , "MPP" , 0);
		sscanf(msg_entra , "MPP%f %f" , &a , &b);
		puntos[i].x = (short)( (a - origen_x) * escala);
		puntos[i].y = (short)( (b - origen_y) * escala);
#ifdef DEBUG
		printf("Dibujo el punto %d %d\n" , (int)puntos[i].x , (int)puntos[i].y);
		if (fichero == CIERTO) fprintf(accion , "Dibujo el punto %d %d\n" , (int)puntos[i].x , (int)puntos[i].y);
#endif
	}
#ifdef DEBUG
	printf("Dibujo\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo\n");
#endif
	XFillPolygon(display , window , gc , puntos , n_lados , Convex , CoordModeOrigin);
	XFlush(display);
}

void ventana_info::dibujar_texto(void)
{
 float x , y;
 unsigned char color;
 char texto[30];

	sscanf(msg_entra , "MFT%f %f %c %s" , &x , &y , &color , texto);
	x = (x - origen_x) * escala;
	y = (y - origen_y) * escala;
#ifdef DEBUG
	printf("Dibujo el texto %d %d '%s' %d\n" , (int)x , (int)y , texto , color);
	if (fichero == CIERTO) fprintf(accion , "Dibujo el texto %d %d '%s' %d\n" , (int)x , (int)y , texto , color);
#endif
	XSetForeground(display , gc , colores[(color%NUM_COLOR)]);
	XDrawString(display , window , gc , (int)x , (int)y , texto , strlen(texto));
	XFlush(display);
}

void ventana_info::poner_informacion(void)
{
 Arg args[1];
 char linea[100];

	sprintf(linea , "  Escala: %5.1f       Origen x: %4d       Origen y: %4d       %s  " , escala , origen_x , origen_y , (mon->di_activo() == CIERTO) ? "Activo" : "Parado");
	XtSetArg(args[0] , XtNlabel , linea);
	XtSetValues(info , args , 1);
	XFlush(display);
}
