/******************************************************************************\
*                                                                              *
*       FIGURAS             Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para definir figuras de dos dimensiones.                     *
*                                                                              *
*       22/febrero/1994                                                        *
\******************************************************************************/

#ifndef _FIGURAS_
#define _FIGURAS_

#include <stdio.h>
#include "coord.hpp"

class figura{
	protected:
		unsigned char color;
		figura *sig;
	public:
		inline figura(void) { sig = NULL; }
		virtual ~figura(void) { }
		inline unsigned char di_color(void) { return(color); }
		inline figura* di_sig(void) { return(sig); }
		inline void fijar_color(unsigned char c) { color = c; }
		int crear(char *f_fig);
		void dibujar_figuras(void);
		virtual void dibujar(unsigned char color) = 0;
		void enviar_figuras(int sock, int *accesible);
		virtual void enviar(int sock , int *accesible) = 0;
		int escribir_figuras(char *fich , int copia);
		virtual void escribir(FILE *fig) = 0;
};

class recta:public figura{
	private:
		punto_car a;
		punto_car b;
	public:
		inline recta(void) { }
		recta(int ax , int ay , int bx , int by , int c);
		inline ~recta(void) { if(sig != NULL) delete(sig); }
		inline void fijar_recta(int ax , int ay , int bx , int by)
			{ a.fijar_punto(ax , ay); b.fijar_punto(bx , by); }
		void dibujar(unsigned char color);
		void escribir(FILE *fig);
		void enviar(int sock , int *accesible);
};

class poligono:public figura{
	private:
		int n_lados;
		punto_car centro;
		float angulo;
		punto_pol *puntos;
	public:
		inline poligono(void) { puntos = NULL; }
		poligono(int cx , int cy , float a , int n , punto_pol *p , int c);
		inline ~poligono(void) { if(puntos != NULL) delete(puntos); if(sig != NULL) delete(sig); }
		inline void fijar_poligono(int cx , int cy , float a , int n , punto_pol *p)
			{ angulo = a; n_lados = n; centro.fijar_punto(cx , cy); puntos = p; }
		void dibujar(unsigned char color);
		void escribir(FILE *fig);
		void enviar(int sock , int *accesible);
};

class circulo:public figura{
	private:
		punto_car centro;
		int radio;
	public:
		inline circulo(void) { }
		circulo(int x , int y , int a , int c);
		inline ~circulo(void) { if(sig != NULL) delete(sig); }
		inline void fijar_circulo(int ax , int ay , int r)
			{ centro.fijar_punto(ax , ay); radio = r; }
		void dibujar(unsigned char color);
		void escribir(FILE *fig);
		void enviar(int sock , int *accesible);
};

#endif
