/*       SENSOR              Ignacio  Merino  Lagunilla                       */

#include <math.h>
#include <stdlib.h>
#include "global.hpp"
#include "sensor.hpp"

//#define 	DEBUG


void sensor::explorar_sensores(robot *rob)
{
 sensor *aux = this;
 int i = 0;

	while(aux != NULL)
	{
		aux->explorar(rob , aux->salida);
		aux = aux->sig;
		++i;
	}
#ifdef DEBUG
	printf("Exploro los %d sensores del robot '%s'\n" , i , rob->di_nombre());
	if(fichero == CIERTO) fprintf(accion , "Exploro los %d sensores del robot '%s'\n" , i , rob->di_nombre());
#endif
}

void laser::crear(sensor *&ini , sensor *&fin , char *datos)
{
 int dis;
 float ang;

	if(ini == NULL)
	{
		ini = fin = this;
	}
	else
	{
		ant = fin;
		fin->fijar_sig(this);
		fin = this;
	}
	sscanf(datos , "%d %f %f %d" , &dis , &ang , &angulo , &rango);
	pos.fijar_punto(dis , ang);
#ifdef DEBUG
	printf("Creo el sensor laser dis = %d ang = %d orientacion = %d rango = %d\n" , dis , grados(ang) , grados(angulo) , rango);
	if(fichero == CIERTO) fprintf(accion , "Creo el sensor laser dis = %d ang = %d orientacion = %d rango=%d\n" , dis , grados(ang) , grados(angulo) , rango);
#endif
}

void laser::explorar(robot *rob , float *salida)
{
 unsigned char color = 0;
 float x , y , an , dis = 0 , s , c;

	an = angulo(rob->di_angulo() + pos.di_ang());
	x = (rob->di_pos()->di_x() + (pos.di_dis() + 2) * cos(an));
	y = (rob->di_pos()->di_y() - (pos.di_dis() + 2) * sin(an));
	an = angulo(rob->di_angulo() + angulo);
	s = sin(an); c = cos(an);
	while(dis < rango && color < COLOR_INV)
	{
		dis++;
		color = mapa->di_punto((int)(x + dis * c) , (int)(y - dis * s));
#ifdef DEBUG
		printf("robot '%s' sensor laser x = %d y = %d distandia = %d color = %d\n" , rob->di_nombre() , (int)(x + dis * c) , (int)(y - dis * s) , (int)dis , color);
		if(fichero == CIERTO) fprintf(accion , "robot '%s' sensor laser x = %d y = %d distandia = %d color = %d\n" , rob->di_nombre() , (int)(x + dis * c) , (int)(y - dis * s) , (int)dis , color);
#endif
	}
	salida[0] = dis;
	if(color < COLOR_INV) salida[1] = 0;
	else salida[1] = color;
	sprintf(msg_sale , "RSL%f %f" , salida[0] , salida[1]);
	enviar_msg(rob->di_sock() , rob->di_accesible2());
	if(rob->di_dibu_sen() == CIERTO)
	{
		sprintf(msg_sale , "MFR%.3f %.3f %.3f %.3f %c" , x , y , (x + (dis - 2) * c) , (y - (dis - 2) * s) , rob->di_rastro());
		ini_m->di_sig()->enviar_figura();
	}
#ifdef DEBUG
	printf("robot '%s' sensor laser distandia = %d color = %d\n" , rob->di_nombre() , (int)salida[0] , (int)salida[1]);
	if(fichero == CIERTO) fprintf(accion , "robot '%s' sensor laser distandia = %d color = %d\n" , rob->di_nombre() , (int)salida[0] , (int)salida[1]);
#endif
}

void sonar::crear(sensor *&ini , sensor *&fin , char *datos)
{
 int dis;
 float ang;

	if(ini == NULL)
	{
		ini = fin = this;
	}
	else
	{
		ant = fin;
		fin->fijar_sig(this);
		fin = this;
	}
	sscanf(datos , "%d %f %f %d %f %f %c" , &dis , &ang , &angulo , &rango , &ang_sec , &intervalo , &tipo);
	pos.fijar_punto(dis , ang);
#ifdef DEBUG
	printf("Creo el sensor sonar dis = %d ang = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(angulo) , rango , grados(ang_sec) , grados(intervalo) , tipo);
	if(fichero == CIERTO) fprintf(accion , "Creo el sensor sonar dis = %d ang = %d orientacion = %d rango = %d sector %d intervalo %d tipo %d\n" , dis , grados(ang) , grados(angulo) , rango , grados(ang_sec) , grados(intervalo) , tipo);
#endif
}

void sonar::explorar(robot *rob,float *salida)
{
 unsigned char color = 0 , ant_col = 0;
 float x , y , an , dis = 0 , ang , angu , s , c;
 int cuantos , i;
 float max = 0 , min = rango , med = 0;

 	angu = rob->di_angulo();
	an = angulo(angu + pos.di_ang());
	x = (rob->di_pos()->di_x() + (pos.di_dis() + 2) * cos(an));
	y = (rob->di_pos()->di_y() - (pos.di_dis() + 2) * sin(an));
	cuantos = (int)(ang_sec / intervalo);
	ang = angulo(angu + angulo - (ang_sec / 2));
	for(i = 0 ; i <= cuantos ; i++)
	{
		dis = 0; color = 0;
		an = angulo(ang + intervalo * i);
		s = sin(an); c = cos(an);
		while(dis < rango && color < COLOR_INV)
		{
			dis++;
			color = mapa->di_punto((int)(x + dis * c) , (int)(y - dis * s));
#ifdef DEBUG
			printf("robot '%s' sensor sonar x = %d y = %d distandia = %d color = %d\n" , rob->di_nombre() , (int)(x + dis * c) , (int)(y - dis * s) , (int)dis , color);
			if(fichero == CIERTO) fprintf(accion , "robot '%s' sensor sonar x = %d y = %d distandia = %d color = %d\n" , rob->di_nombre() , (int)(x + dis * c) , (int)(y - dis * s) , (int)dis , color);
#endif
		}
		if(color > (COLOR_INV - 1)) ant_col = color;
		if(tipo == 1) { if(dis < min) min = dis; }
		else if(tipo == 3) { if(dis > max) max = dis; }
		else med+= dis / (cuantos + 1);
		if(rob->di_dibu_sen() == CIERTO)
		{
			sprintf(msg_sale , "MFR%.3f %.3f %.3f %.3f %c" , x , y , (x + (dis - 2) * c) , (y - (dis - 2) * s) , rob->di_rastro());
			ini_m->di_sig()->enviar_figura();
		}
	}
	if(tipo == 1) salida[0] = min;
	else if(tipo == 3) salida[0] = max;
	else salida[0] = med;
	if(ant_col < COLOR_INV) salida[1] = 0;
	else salida[1] = ant_col;
	sprintf(msg_sale , "RSS%f %f" , salida[0] , salida[1]);
	enviar_msg(rob->di_sock() , rob->di_accesible2());
}

void GPS::crear(sensor *&ini , sensor *&fin , char *datos)
{
 int dis;
 float ang;

	if(ini == NULL)
	{
		ini = fin = this;
	}
	else
	{
		ant = fin;
		fin->fijar_sig(this);
		fin = this;
	}
#ifdef DEBUG
	printf("Creo el sensor GPS\n");
	if(fichero == CIERTO) fprintf(accion , "Creo el sensor GPS\n");
#endif
}

void GPS::explorar(robot *rob , float *salida)
{
	salida[0] = rob->di_pos()->di_x();
	salida[1] = rob->di_pos()->di_y();
	salida[2] = rob->di_angulo();
	sprintf(msg_sale , "RSG%f %f %f" , salida[0] , salida[1] , salida[2]);
	enviar_msg(rob->di_sock() , rob->di_accesible2());
#ifdef DEBUG
	printf("robot '%s' sensor GPS x = %d y = %d sentido = %d\n" , rob->di_nombre() , (int)salida[0] , (int)salida[1] , grados(salida[2]));
	if(fichero == CIERTO) fprintf(accion , "robot %s sensor GPS x = %d y = %d sentido = %d\n" , rob->di_nombre() , (int)salida[0] , (int)salida[1] , grados(salida[2]));
#endif
}
