/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Box.h>

#include "global.hpp"

//#define 	DEBUG


Widget aplicacion , dibujo , acerca , ayuda;
XtAppContext contexto;

void ver_dibujar(Widget w , caddr_t dato , XEvent *evento , char *nada)
{
	ventana->redibujar(0);
}

void parar(Widget w , XtPointer dato , XtPointer nada)
{
	if(activo == CIERTO)
	{
		ini_r->di_sig()->parar_robots();
		ini_m->di_sig()->parar_monitores();
		activo = FALSO;
#ifdef DEBUG
		printf("Paro a todos los procesos\n");
		if (fichero == CIERTO) fprintf(accion , "Paro a todos los procesos\n");
#endif
	}
	else
	{
		ini_r->di_sig()->continuar_robots();
		ini_m->di_sig()->continuar_monitores();
		activo = CIERTO;
#ifdef DEBUG
		printf("Mando continuar a todos los procesos\n");
		if (fichero == CIERTO) fprintf(accion , "Mando continuar a todos los procesos\n");
#endif
	}
}

void terminar(Widget w , XtPointer dato , XtPointer nada)
{
	final = CIERTO;
}

void copia_figuras(Widget w , XtPointer dato , XtPointer nada)
{
	figuras->escribir_figuras(f_figcop , 1);
}

void copia_mapa(Widget w , XtPointer dato , XtPointer nada)
{
	mapa->escribir(f_mapcop , 1);
}

void copia_monitores(Widget w , XtPointer dato , XtPointer nada)
{
	ini_m->di_sig()->escribir_lista(f_moncop , 1);
}

void copia_robots(Widget w , XtPointer dato , XtPointer nada)
{
	ini_r->di_sig()->escribir_lista(f_robcop , 1);
}

void refrescar(Widget w , XtPointer dato , XtPointer nada)
{
	ventana->redibujar(1);
}

void fijar_pasos_dibujo(Widget w , XtPointer dato , XtPointer nada)
{
	printf("Cada cuantos pasos se dibuja: ");
	scanf("%d" , &pasos_dibujo);
#ifdef DEBUG
	printf("Se dibuja cada %d pasos\n" , pasos_dibujo);
	if (fichero == CIERTO) fprintf(accion , "Se dibuja cada %d pasos\n" , pasos_dibujo);
#endif
}

void inc_pasos_dibujo(Widget w , XtPointer dato , XtPointer nada)
{
	if(pasos_dibujo < 100) pasos_dibujo++;
#ifdef DEBUG
	printf("Se dibuja cada %d pasos\n" , pasos_dibujo);
	if (fichero == CIERTO) fprintf(accion , "Se dibuja cada %d pasos\n" , pasos_dibujo);
#endif
}

void dec_pasos_dibujo(Widget w , XtPointer dato , XtPointer nada)
{
	if(pasos_dibujo > 0) pasos_dibujo--;
#ifdef DEBUG
	printf("Se dibuja cada %d pasos\n" , pasos_dibujo);
	if (fichero == CIERTO) fprintf(accion , "Se dibuja cada %d pasos\n" , pasos_dibujo);
#endif
}

void ver_acerca(Widget w , XtPointer dato , XtPointer nada)
{
}

void ver_ayuda(Widget w , XtPointer dato , XtPointer nada)
{
}

void ventana_info::crear(void)
{
 char *nombre[] = { "SimDAI  V 1.0   -   Mundo" , NULL };
 Widget shell , barra , boton1 , boton2 , boton3 , boton4 , menu1 , menu2 , menu3 , menu4 , opcion;
 int screen;
 int i = 1;
 static char *recursos[] = {
	"*Box*background:				White",
	"*SimpleMenu*foreground:			SteelBlue",
	"*MenuButton.foreground:			Red",
	"*font:						*times*medium*18*iso8859-1",
	"*boton1.label:				Fin",
	"*boton2.label:				Copias",
	"*boton3.label:				Opciones",
	"*boton4.label:				Ayuda",
	"*SimpleMenu*SmeBSB*RowHeight:	25",
	"*SimpleMenu*SmeLine*height:		10",
	"*dibujo.width:				550",
	"*dibujo.height:				310",
	"*barra.width:					550",
	"*acerca.width:				200",
	"*acerca.height:				100",
	"*ayuda.width:					200",
	"*ayuda.height:				100",
	NULL
 };

	aplicacion = XtVaAppInitialize(&contexto , "XSimDAI.Mun" , NULL , 0 , &i , nombre , recursos , NULL);

	shell = XtVaCreateManagedWidget("shell" , boxWidgetClass , aplicacion , NULL);

	barra = XtVaCreateManagedWidget("barra" , boxWidgetClass , shell , NULL);

	boton1 = XtVaCreateManagedWidget("boton1" , menuButtonWidgetClass , barra , NULL);
	boton2 = XtVaCreateManagedWidget("boton2" , menuButtonWidgetClass , barra , NULL);
	boton3 = XtVaCreateManagedWidget("boton3" , menuButtonWidgetClass , barra , NULL);
	boton4 = XtVaCreateManagedWidget("boton4" , menuButtonWidgetClass , barra , NULL);

	menu1 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton1 , NULL , 0);
	menu2 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton2 , NULL , 0);
	menu3 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton3 , NULL , 0);
	menu4 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton4 , NULL , 0);

	opcion = XtCreateManagedWidget("Parar / Continuar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , parar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea11" , smeLineObjectClass , menu1 , NULL , 0);
	opcion = XtCreateManagedWidget("Terminar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , terminar , (XtPointer) i);

	opcion = XtCreateManagedWidget("Copia de figuras" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , copia_figuras , (XtPointer) i);
	opcion = XtCreateManagedWidget("Copia del mapa" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , copia_mapa , (XtPointer) i);
	opcion = XtCreateManagedWidget("Copia de monitores" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , copia_monitores , (XtPointer) i);
	opcion = XtCreateManagedWidget("Copia de robots" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , copia_robots , (XtPointer) i);

	opcion = XtCreateManagedWidget("Refrescar" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , refrescar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea21" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Fijar Pasos Dibujo" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , fijar_pasos_dibujo , (XtPointer) i);
	opcion = XtCreateManagedWidget("Incrementar Pasos Dibujo" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , inc_pasos_dibujo , (XtPointer) i);
	opcion = XtCreateManagedWidget("Decrementar Pasos Dibujo" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , dec_pasos_dibujo , (XtPointer) i);

	opcion = XtCreateManagedWidget("Acerca" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_acerca , (XtPointer) i);
	opcion = XtCreateManagedWidget("Ayuda" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_ayuda , (XtPointer) i);

	dibujo = XtCreateManagedWidget("dibujo" , simpleWidgetClass , shell , NULL , 0);
	display = XtDisplay(dibujo);
	screen = DefaultScreen(display);
	XtAddEventHandler(dibujo , ExposureMask , FALSE , ver_dibujar , NULL);
	gc = XtGetGC(dibujo , 0 , 0);
	XSetForeground(display , gc , BlackPixel(display , screen));
	XSetBackground(display , gc , WhitePixel(display , screen));

	acerca = XtCreatePopupShell("acerca" , transientShellWidgetClass , shell , NULL , 0);

	ayuda = XtCreatePopupShell("ayuda" , transientShellWidgetClass , shell , NULL , 0);

	XtRealizeWidget(aplicacion);
	window = XtWindow(dibujo);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
}

void ventana_info::liberar(void)
{
	XtReleaseGC(dibujo , gc);
	XtRemoveEventHandler(dibujo , ExposureMask , FALSE , ver_dibujar , NULL);
	XtCloseDisplay(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(int borrar)
{
 char linea[100];
 int y = 30;
 robot *rob = ini_r->di_sig();
 monitor *mon = ini_m->di_sig();

#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
	if(borrar != 0) XClearWindow(display , window);
	sprintf(linea , "Mundo     pasos dibujo = %d     %s" , pasos_dibujo , (activo == CIERTO) ? "Activo" : "Parado");
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	while(mon != NULL)
	{
		strcpy(linea , mon->di_datos());
		XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
		mon = mon->di_sig();
	}
#ifdef DEBUG
	printf("Dibujo los procesos monitor en la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo los procesos monitor en la ventana de informacion\n");
#endif
	while(rob != NULL)
	{
		strcpy(linea , rob->di_datos());
		XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
		rob = rob->di_sig();
	}
#ifdef DEBUG
	printf("Dibujo los procesos robot en la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo los procesos robot en la ventana de informacion\n");
#endif
	XFlush(display);
}

void ventana_info::comprobar_eventos(void)
{
	if (XtAppPending(contexto) != 0)
	{
		XtAppNextEvent(contexto , &evento);
		XtDispatchEvent(&evento);
	}
	else XFlush(display);
}
