/*       CONECTAR            Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "global.hpp"

//#define 	DEBUG


int robot::conectar(void)
{
 int puerto;
 struct sockaddr_in dir;
 struct hostent *host;
 struct linger opcion;
 struct timeval espera;
 struct fd_set test;

	if((sock = socket(AF_INET , SOCK_STREAM , 0)) < 0)
	{
		printf("\aERROR: No puedo crear el socket.\n");
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo crear el socket.\n");
		return(-1);
	}
#ifdef DEBUG
	printf("Creo el socket sd = %d\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Creo el socket sd = %d\n" , sock);
#endif
	if( (host = gethostbyname(servidor)) == NULL)
	{
        	printf("\aERROR: No puedo acceder a los datos del servidor '%s'.\n" , servidor);
        	if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo acceder a los datos del servidor '%s'.\n" , servidor);
		close(sock);
		return(-2);
	}
#ifdef DEBUG
	printf("Obtengo los datos del servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Obtengo los datos del servidor '%s'\n" , servidor);
#endif
	bzero((char *) &dir , sizeof(struct sockaddr_in));
	dir.sin_family = host->h_addrtype;
	memcpy((char *) &dir.sin_addr , host->h_addr , host->h_length);
	dir.sin_port = htons(puerto_r);
	if(connect(sock , (struct sockaddr *) &dir , sizeof(dir)) < 0)
	{
        	printf("\aERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
        	if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		close(sock);
		return(-3);
	}
#ifdef DEBUG
	printf("Conectado al servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Conectado al servidor '%s'\n" , servidor);
#endif
	opcion.l_linger = 5;
	opcion.l_onoff = 1;
	setsockopt(sock , SOL_SOCKET , SO_LINGER , &opcion , sizeof(opcion));
#ifdef DEBUG
	printf("Socket %d de cierre diferido\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Socket %d de cierre diferido\n" , sock);
#endif
	espera.tv_sec = 5;
	espera.tv_usec = 0;
	FD_ZERO(&test);
	FD_SET(sock , &test);
	select(sock+1 , SOCKET &test , NULL , NULL , &espera);
	if(FD_ISSET(sock , &test))
	{
		read(sock , msg_entra , MAX_MSG);
		if(sscanf(msg_entra , "RNP%d" , &puerto) < 0)
		{
			printf("\aERROR: Mensaje incorrecto del servidor '%s'.\n" , servidor);
			if(fichero == CIERTO) fprintf(accion , "ERROR: Mensaje incorrecto del servidor '%s'.\n" , servidor);
			close(sock);
			return(-4);
		}
#ifdef DEBUG
		printf("Calculo el puerto %d\n" , puerto);
		if(fichero == CIERTO) fprintf(accion , "Calculo el puerto %d\n" , puerto);
#endif
	}
	else
	{
		printf("\aERROR: El servidor '%s' no responde.\n" , servidor);
		if(fichero == CIERTO) fprintf(accion , "ERROR: El servidor '%s' no responde.\n" , servidor);
		close(sock);
		return(-5);
	}
	strcpy(msg_sale , "RAP");
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el mensaje '%s'\n" , msg_sale);
	if(fichero == CIERTO) fprintf(accion , "Envio el mensaje '%s'\n" , msg_sale);
#endif
	close(sock);
	if( (sock = socket(AF_INET , SOCK_STREAM , 0)) < 0)
	{
		printf("\aERROR: No puedo crear el socket.\n");
		if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo crear el socket.\n");
		return(-6);
	}
#ifdef DEBUG
	printf("Creo el socket sd = %d\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Creo el socket sd = %d\n" , sock);
#endif
	dir.sin_port = htons(puerto);
	if(connect(sock , (struct sockaddr *) &dir , sizeof(dir)) < 0)
	{
		printf("\aERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
        	if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo conectarme con el servidor '%s'.\n" , servidor);
		close(sock);
		return(-7);
	}
#ifdef DEBUG
	printf("Conectado al servidor '%s'\n" , servidor);
	if(fichero == CIERTO) fprintf(accion , "Conectado al servidor '%s'\n" , servidor);
#endif
	opcion.l_linger = 5;
	opcion.l_onoff = 1;
	setsockopt(sock , SOL_SOCKET , SO_LINGER , &opcion , sizeof(opcion));
#ifdef DEBUG
	printf("Socket %d de cierre diferido\n" , sock);
	if(fichero == CIERTO) fprintf(accion , "Socket %d de cierre diferido\n" , sock);
#endif
	switch(rob->enviar_datos())
	{
		case 0:
#ifdef DEBUG
			printf("Envio los datos al servidor '%s'\n" , servidor);
			if(fichero == CIERTO) fprintf(accion , "Envio los datos al servidor '%s'\n" , servidor);
#endif
			conectado = CIERTO;
			break;
		case 1:
		case 2:
		case 3:
			printf("\aERROR: No hay memoria en el mundo para los datos del robot.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: No hay memoria en el mundo para los datos del robot.\n");
			close(sock);
			return(-8);
			break;
		case 4:
			printf("\aERROR: El mundo no entiende los datos del robot.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: El mundo no entiende los datos del robot.\n");
			close(sock);
			return(-9);
			break;
		case 5:
		case 6:
			printf("\aERROR: La posicion del robot esta fuera del mapa del mundo.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: La posicion del robot esta fuera del mapa del mundo.\n");
			close(sock);
			return(-10);
			break;
		case 7:
			printf("\aERROR: Existe otro robot con el mismo nombre.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: Existe otro robot con el mismo nombre.\n");
			close(sock);
			return(-11);
			break;
		case 8:
			printf("\aERROR: La posicion que quiere ocupar el robot ya esta ocupada.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: La posicion que quiere ocupar el robot ya esta ocupada.\n");
			close(sock);
			return(-12);
			break;
	}
	if(ini_ri != NULL) delete(ini_ri);
	ini_ri = fin_ri = NULL;
	return(0);
}

int robot::enviar_datos(void)
{
 int codigo;
 sensor *sen = ini_s;

	sprintf(msg_sale , "DRN%s" , nombre);
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el nombre '%s' del proceso robot\n" , nombre);
	if(fichero == CIERTO) fprintf(accion , "Envio el nombre '%s' del proceso robot\n" , nombre);
#endif
	sprintf(msg_sale,"DRP%f %f %f" , pos.di_x() , pos.di_y() , angulo);
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio la posicion x = %d y = %d orientacion = %d del proceso robot '%s'\n" , (int)pos.di_x() , (int)pos.di_y() , grados(angulo) , nombre);
	if(fichero == CIERTO) fprintf(accion , "Envio la posicion x = %d y = %d orientacion = %d del proceso robot '%s'\n" , (int)pos.di_x() , (int)pos.di_y() , grados(angulo) , nombre);
#endif
	sprintf(msg_sale,"DRA%d %d %c %c %c" , radio , ruedas , color , rastro , sentido);
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el aspecto radio = %d ruedas = %d color = %d rastro = %d sentido = %d del proceso robot '%s'\n" , radio , ruedas , color , rastro , sentido , nombre);
	if(fichero == CIERTO) fprintf(accion , "Envio el aspecto radio = %d ruedas = %d color = %d rastro = %d sentido = %d del proceso robot '%s'\n" , radio , ruedas , color , rastro , sentido , nombre);
#endif
	while(sen != NULL)
	{
		sen->enviar_datos(this);
		sen = sen->di_sig();
	}
	sprintf(msg_sale , "DRF");
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el fin '%s' de datos del proceso robot '%s'\n" , msg_sale , nombre);
	if(fichero == CIERTO) fprintf(accion,"Envio el fin '%s' de datos del proceso robot '%s'\n" , msg_sale , nombre);
#endif
	recibir_msg(sock , "CDR" , 0);
	sscanf(msg_entra , "CDR%d" , &codigo);
#ifdef DEBUG
	printf("Recibo el codigo %d\n" , codigo);
	if(fichero == CIERTO) fprintf(accion , "Recibo el codigo %d\n" , codigo);
#endif

	return(codigo);
}

void robot::desconectar(void)
{
	strcpy(msg_sale , "RHT");
	enviar_msg(sock);
#ifdef DEBUG
	printf("Envio el mensaje de fin '%s' al servidor '%s'\n" , msg_sale , servidor);
	if(fichero == CIERTO) fprintf(accion , "Envio el mensaje de fin '%s' al servidor '%s'\n" , msg_sale , servidor);
#endif
	conectado = FALSO;
	acabar = CIERTO;
	recibir_msg(sock , "RPT" , 0);
	shutdown(sock , 2);
}

void robot::parar(void)
{
	if(activo == CIERTO)
	{
		strcpy(msg_sale , "RHP");
		enviar_msg(sock);
		activo = FALSO;
		ventana->redibujar();
#ifdef DEBUG
		printf("Paro al proceso robot '%s'\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "Paro al proceso robot '%s'\n" , nombre);
#endif
	}
	else
	{
		strcpy(msg_sale , "RHC");
		enviar_msg(sock);
		activo = CIERTO;
		ventana->redibujar();
#ifdef DEBUG
		printf("Mando continuar al proceso robot '%s'\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "Mando continuar al proceso robot '%s'\n" , nombre);
#endif
	}

#ifdef DEBUG
	printf("Envio el mensaje de paro/marcha '%s' al servidor '%s'\n" , msg_sale , servidor);
	if(fichero == CIERTO) fprintf(accion,"Envio el mensaje de paro/marcha '%s' al servidor '%s'\n" , msg_sale , servidor);
#endif
}
