/*       ROBOT_INF           Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <string.h>

#include "global.hpp"
#include "rob_inf.hpp"

//#define 	DEBUG


robot_inf::robot_inf(char *nom)
{
	if(ini_ri == NULL)
	{
		sig = ant = NULL;
		ini_ri = fin_ri = this;
	}
	else
	{
        	sig = NULL;
		ant = fin_ri;
		fin_ri->fijar_sig(this);
		fin_ri = this;
	}
	strcpy(nombre , nom);
#ifdef DEBUG
	printf("Llega un nuevo robot '%s'\n" , nombre);
	if(fichero == CIERTO) fprintf(accion , "Llega un nuevo robot '%s'\n" , nombre);
#endif
}

void robot_inf::borrar(char *nom)
{
 robot_inf *aux = ini_ri;

	while(aux != NULL && strcmp(aux->nombre , nom) != 0) aux = aux->sig;
	if(aux != NULL)
	{
		if(aux == ini_ri) ini_ri = aux->sig;
		if(aux == fin_ri) fin_ri = aux->ant;
		if(aux->ant != NULL) aux->ant->fijar_sig(aux->sig);
		if(aux->sig != NULL) { aux->sig->fijar_ant(aux->ant); aux->sig = NULL; }
#ifdef DEBUG
		printf("Se borra el robot '%s'\n" , nombre);
		if(fichero == CIERTO) fprintf(accion , "Se borra el robot '%s'\n" , nombre);
#endif
		delete(aux);
	}
}

int robot_inf::escribir(int copia)
{
 FILE *inf;
 static int num = 1;
 char nombre[50] , version[10];
 robot_inf *aux = this;

	sprintf(nombre , "conoce.%s" , rob->di_nombre());
	if(copia != 0)
	{
		sprintf(version , ".%d" , num);
		strcat(nombre , version);
		++num;
	}
	if ( (inf = fopen(nombre , "wt")) == NULL)
	{
		printf("\aERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		if (fichero == CIERTO) fprintf(accion , "ERROR: No puedo habrir el fichero '%s'.\n" , nombre);
		return(-1);
	}
#ifdef DEBUG
	printf("Creo el fichero '%s' para escribir los robots\n" , nombre);
	if (fichero == CIERTO) fprintf(accion , "Creo el fichero '%s' para escribir los robot\n" , nombre);
#endif
	while(aux != NULL)
	{
		fprintf(inf , "%s\n" , aux->nombre);
		aux = aux->sig;
	}
#ifdef DEBUG
	printf("Escribo los robots en el fichero '%s'\n" , nombre);
	if (fichero == CIERTO) fprintf(accion , "Escribo los robots en el fichero '%s'\n" , nombre);
#endif
	fclose(inf);
	return(0);
}
