/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <string.h>

#include "global.hpp"

//#define 	DEBUG


void conectar(void)
{
	if(conectado == FALSO)
	{
		printf("Nombre del servidor: ");
		scanf("%s" , servidor);
		printf("Numero de puerto: ");
		scanf("%d" , &puerto_r);
		rob->conectar();
		if(conectado == CIERTO) ventana->redibujar();
#ifdef DEBUG
		printf("Me conecto al servidor '%s' %d\n" , servidor , conectado);
		if(fichero == CIERTO) fprintf(accion , "Me conecto al servidor '%s' %d\n" , servidor , conectado);
#endif
	}
}

void enviar_mensaje(void)
{
 char mens[45] , destino[6] , linea[100];
 robot_inf *aux = ini_ri;

	if(conectado == CIERTO)
	{
		printf("Mensaje: ");
		scanf("%s" , linea);
		strncpy(mens , linea , 44); mens[44] = '\0';
		printf("Destino: ");
		scanf("%s" , linea);
		strncpy(destino , linea , 5); destino[5] = '\0';
		while(aux != NULL && strcmp(destino , aux->di_nombre()) != 0) aux = aux->di_sig();
		if(aux != NULL)
		{
			sprintf(msg_sale , "REM%s %s" , destino , mens);
			rob->enviar_msg(rob->di_sock());
#ifdef DEBUG
			printf("Envio el mensaje '%s' al robot '%s'\n" , mens , destino);
			if(fichero == CIERTO) fprintf(accion , "Envio el mens '%s' al robot '%s'\n" , mensaje , destino);
#endif
		}
		else
		{
#ifdef DEBUG
			printf("No puedo enviar el mensaje '%s' al robot '%s'\n" , mens , destino);
			if(fichero == CIERTO) fprintf(accion , "No puedo enviar el mensaje '%s' al robot '%s'\n" , mens , destino);
#endif
		}
	}
}

void ventana_info::crear(void)
{
 int screen;
 XSizeHints hint;
 unsigned long foreground , background;

	display = XOpenDisplay("");
	screen = DefaultScreen(display);
	background = WhitePixel(display , screen);
	foreground = BlackPixel(display , screen);
	hint.x = 0;
	hint.y = 0;
	hint.width = 410;
	hint.height = 250;
	hint.flags = PPosition | PSize;
	window = XCreateSimpleWindow(display , DefaultRootWindow(display),
		hint.x , hint.y , hint.width , hint.height , 7 ,
		foreground , background);
	XSetStandardProperties(display , window , "SimDAI  V 1.0  -  Robot",
		"SimDAI" , None , NULL , 0 , &hint);
	gc = XCreateGC(display , window , 0 , 0);
	XSetBackground(display , gc , background);
	XSetForeground(display , gc , foreground);
	XSelectInput(display , window , (KeyPressMask | ExposureMask));
	XMapRaised(display , window);
	XFlush(display);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
}

void ventana_info::liberar(void)
{
	XFreeGC(display , gc);
	XDestroyWindow(display , window);
	XCloseDisplay(display);
	XFlush(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(void)
{
 char linea[100];
 int y = 30;
 sensor *aux = rob->di_ini_s();

	sprintf(linea , "Robot:       %10s     %s" , rob->di_nombre() , (rob->di_activo()) ? "Activo" : "Parado");
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	sprintf(linea , "Posicion     X =%5d     Y =%5d     sentido =%4d" , (int)rob->di_pos()->di_x() , (int)rob->di_pos()->di_y() , grados( rob->di_angulo() ));
	XDrawImageString( display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	while(aux != NULL)
	{
		strcpy(linea , aux->di_datos());
		XDrawImageString(display , window , gc , 50 , y , linea , strlen(linea)); y+=30;
 		aux = aux->di_sig();
	}
	sprintf(linea , "Velodidad     V izq =%6.2f     V der =%6.2f" , rob->di_v1() , rob->di_v2());
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	sprintf(linea , "Numero de choques = %5d" , rob->di_choques());
	XDrawImageString(display , window , gc ,20 , y , linea , strlen(linea));
	XFlush(display);
#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
}

int eventos(Display *display , XEvent *evento , char *nada)
{
 KeySym key;
 char buffer[8];
 int teclas;

	XNextEvent(display , evento);
	switch(evento->type)
	{
	   case Expose:
		if(evento->xexpose.count==0)
		{
#ifdef DEBUG
			printf("Nuevo evento de esposicion\n");
			if (fichero == CIERTO) fprintf(accion , "Nuevo evento de esposicion\n");
#endif
			ventana->redibujar();
		}
		break;

	   case MappingNotify:
		XRefreshKeyboardMapping((struct XMappingEvent *) evento);
		break;

	   case KeyPress:
		teclas = XLookupString((struct XKeyEvent *) evento , buffer , 8 , &key , 0);
		if (teclas == 1 && buffer[0] == 'q') { if(conectado == CIERTO) rob->desconectar(); acabar = final = CIERTO; }
		else if (teclas == 1 && buffer[0] == 's') { if(conectado == CIERTO) rob->parar(); }
		else if (teclas == 1 && buffer[0] == 'c') conectar();
		else if (teclas == 1 && buffer[0] == 'd') { if(conectado == CIERTO) rob->desconectar(); }
		else if (teclas == 1 && buffer[0] == 'r') { if(conectado == CIERTO) rob->ver_rastro(); }
		else if (teclas == 1 && buffer[0] == 't') { if(conectado == CIERTO) rob->no_ver_rastro(); }
		else if (teclas == 1 && buffer[0] == 'v') { if(conectado == CIERTO) rob->ver_sensores(); }
		else if (teclas == 1 && buffer[0] == 'b') { if(conectado == CIERTO) rob->no_ver_sensores(); }
		else if (teclas == 1 && buffer[0] == 'f') ventana->redibujar();
		else if (teclas == 1 && buffer[0] == 'm') enviar_mensaje();
		else if (teclas == 1 && buffer[0] == 'n') ini_ri->escribir(1);
		else if (teclas == 1 && buffer[0] == 'e') rob->di_ini_m()->escribir(1);
#ifdef DEBUG
		printf("Se ha pulsado la tecla '%c'\n" , buffer[0]);
		if (fichero == CIERTO) fprintf(accion , "Se ha pulsado la tecla '%c'\n" , buffer[0]);
#endif
		break;
	   default:
#ifdef DEBUG
	        printf("Nuevo evento no seleccionado\n");
	        if (fichero == CIERTO) fprintf(accion , "Nuevo evento no seleccionado\n");
#endif
		break;
	}
	return(0);
}

void ventana_info::comprobar_eventos(void)
{
	XCheckIfEvent(display , &evento , eventos , NULL);
}
